with Interfaces; use Interfaces;

package body CORBA_Repository_Root_OperationDef_Hash is

   P : constant array (0 .. 3) of Natural :=
     (2, 4, 6, 12);

   T1 : constant array (0 .. 3) of Unsigned_8 :=
     (33, 6, 15, 31);

   T2 : constant array (0 .. 3) of Unsigned_8 :=
     (10, 42, 48, 37);

   G : constant array (0 .. 58) of Unsigned_8 :=
     (12, 2, 0, 20, 0, 14, 27, 14, 0, 0, 0, 0, 13, 0, 7, 18, 0, 0, 0, 13, 0,
      1, 19, 0, 0, 24, 0, 13, 0, 0, 11, 23, 0, 0, 0, 4, 0, 3, 0, 0, 17, 16,
      20, 0, 0, 0, 0, 9, 12, 6, 0, 0, 3, 0, 25, 0, 0, 25, 0);

   function Hash (S : String) return Natural is
      F : constant Natural := S'First - 1;
      L : constant Natural := S'Length;
      F1, F2 : Natural := 0;
      J : Natural;
   begin
      for K in P'Range loop
         exit when L < P (K);
         J  := Character'Pos (S (P (K) + F));
         F1 := (F1 + Natural (T1 (K)) * J) mod 59;
         F2 := (F2 + Natural (T2 (K)) * J) mod 59;
      end loop;
      return (Natural (G (F1)) + Natural (G (F2))) mod 29;
   end Hash;

end CORBA_Repository_Root_OperationDef_Hash;
